solana-with-rpc-optimizations/ci/localnet-sanity.sh

171 lines
3.1 KiB
Bash
Raw Normal View History

#!/usr/bin/env bash
set -e
iterations=1
maybeNoLeaderRotation=
extraNodes=0
usage() {
exitcode=0
if [[ -n "$1" ]]; then
exitcode=1
echo "Error: $*"
fi
cat <<EOF
usage: $0 [options...]
Start a local cluster and run sanity on it
options:
-i [number] - Number of times to run sanity (default: $iterations)
-b - Disable leader rotation
-x - Add an extra fullnode (may be supplied multiple times)
EOF
exit $exitcode
}
2018-07-30 12:51:35 -07:00
cd "$(dirname "$0")"/..
while getopts "h?i:bx" opt; do
case $opt in
h | \?)
usage
;;
i)
iterations=$OPTARG
;;
b)
maybeNoLeaderRotation="--no-leader-rotation"
;;
x)
extraNodes=$((extraNodes + 1))
;;
*)
usage "Error: unhandled option: $opt"
;;
esac
done
source ci/upload-ci-artifact.sh
source scripts/configure-metrics.sh
2018-07-30 12:51:35 -07:00
multinode-demo/setup.sh
2018-07-30 12:51:35 -07:00
backgroundCommands=(
"multinode-demo/drone.sh"
"multinode-demo/bootstrap-leader.sh $maybeNoLeaderRotation"
"multinode-demo/fullnode.sh $maybeNoLeaderRotation"
)
for _ in $(seq 1 $extraNodes); do
backgroundCommands+=(
"multinode-demo/fullnode-x.sh $maybeNoLeaderRotation"
)
done
numNodes=$((2 + extraNodes))
2018-07-30 12:51:35 -07:00
pids=()
logs=()
2018-07-30 12:51:35 -07:00
for cmd in "${backgroundCommands[@]}"; do
2018-07-30 12:51:35 -07:00
echo "--- Start $cmd"
baseCmd=$(basename "${cmd// */}" .sh)
declare log=log-$baseCmd.txt
rm -f "$log"
$cmd > "$log" 2>&1 &
logs+=("$log")
2018-07-30 12:51:35 -07:00
declare pid=$!
pids+=("$pid")
echo "pid: $pid"
done
killBackgroundCommands() {
2018-07-30 12:51:35 -07:00
set +e
for pid in "${pids[@]}"; do
if kill "$pid"; then
wait "$pid"
else
echo -e "^^^ +++\\nWarning: unable to kill $pid"
fi
done
set -e
pids=()
}
shutdown() {
exitcode=$?
killBackgroundCommands
set +e
2018-07-30 12:51:35 -07:00
echo "--- Upload artifacts"
for log in "${logs[@]}"; do
upload-ci-artifact "$log"
tail "$log"
2018-07-30 12:51:35 -07:00
done
2018-07-30 17:09:05 -07:00
exit $exitcode
2018-07-30 12:51:35 -07:00
}
2018-07-30 17:09:05 -07:00
trap shutdown EXIT INT
2018-07-30 12:51:35 -07:00
set -e
declare iteration=1
2018-08-14 11:31:52 -07:00
flag_error() {
echo "Failed (iteration: $iteration/$iterations)"
2018-08-14 11:31:52 -07:00
echo "^^^ +++"
exit 1
}
while [[ $iteration -le $iterations ]]; do
echo "--- Node count ($iteration)"
(
source multinode-demo/common.sh
set -x
client_id=/tmp/client-id.json-$$
$solana_keygen -o $client_id || exit $?
$solana_bench_tps \
--identity $client_id \
--num-nodes $numNodes \
--reject-extra-nodes \
--converge-only || exit $?
rm -rf $client_id
) || flag_error
echo "--- RPC API: getTransactionCount ($iteration)"
(
set -x
curl --retry 5 --retry-delay 2 --retry-connrefused \
-X POST -H 'Content-Type: application/json' \
-d '{"jsonrpc":"2.0","id":1, "method":"getTransactionCount"}' \
http://localhost:8899
) || flag_error
echo "--- Wallet sanity ($iteration)"
(
set -x
timeout 60s scripts/wallet-sanity.sh
) || flag_error
iteration=$((iteration + 1))
done
killBackgroundCommands
2018-08-14 11:31:52 -07:00
echo "--- Ledger verification"
(
source multinode-demo/common.sh
set -x
cp -R "$SOLANA_CONFIG_DIR"/bootstrap-leader-ledger /tmp/ledger-$$
2018-12-04 21:30:08 -08:00
$solana_ledger_tool --ledger /tmp/ledger-$$ verify || exit $?
2018-08-27 17:57:04 -07:00
rm -rf /tmp/ledger-$$
2018-08-14 11:31:52 -07:00
) || flag_error
2018-07-30 12:51:35 -07:00
echo +++
echo "Ok ($iterations iterations)"
2018-07-30 12:51:35 -07:00
exit 0